package com.microservices.pms.product.mapper;

import com.microservices.pms.product.domain.PmsProductPlan;
import org.apache.ibatis.annotations.Mapper;

import java.util.Date;
import java.util.List;

/**
 * 产品计划Mapper接口
 *
 * @author microservices
 * @date 2023-10-10
 */
@Mapper
public interface PmsProductPlanMapper
{
    /**
     * 查询产品计划
     * 
     * @param id 产品计划主键
     * @return 产品计划
     */
    public PmsProductPlan selectPmsProductPlanById(Long id);

    /**
     * 查询产品计划列表
     * 
     * @param pmsProductPlan 产品计划
     * @return 产品计划集合
     */
    public List<PmsProductPlan> selectPmsProductPlanList(PmsProductPlan pmsProductPlan);

    /**
     * 新增产品计划
     * 
     * @param pmsProductPlan 产品计划
     * @return 结果
     */
    public int insertPmsProductPlan(PmsProductPlan pmsProductPlan);

    /**
     * 修改产品计划
     * 
     * @param pmsProductPlan 产品计划
     * @return 结果
     */
    public int updatePmsProductPlan(PmsProductPlan pmsProductPlan);

    /**
     * 删除产品计划
     * 
     * @param id 产品计划主键
     * @return 结果
     */
    public int deletePmsProductPlanById(Long id);

    /**
     * 批量删除产品计划
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deletePmsProductPlanByIds(Long[] ids);

    /**
     * 查询即将过期的产品计划
     * @param date 时间
     * @return 产品计划列表
     */
    List<PmsProductPlan> selectExpiringPmsProductPlanList(Date date);

    /**
     * 查询产品计划数量
     * @param pmsProductPlan 产品计划查询条件
     * @return 产品计划总数
     */
    Integer selectPmsProductPlanCount(PmsProductPlan pmsProductPlan);

    /**
     * 删除产品下所有计划
     *
     * @param productIdentifier 产品标识
     */
    void deletePmsProductPlanByProductIdentifier(String productIdentifier);
}
